/**
 * ApamaTypes.h
 *
 * Define a common set of type names across all supported platforms.
 *
 * $Copyright(c) 2002, 2004-2006, 2008, 2010 Progress Software Corporation (PSC). All rights reserved.$
 * $Copyright (c) 2013-2014 Software AG, Darmstadt, Germany and/or Software AG USA Inc., Reston, VA, USA, and/or its subsidiaries and/or its affiliates and/or their licensors.$
 * Use, reproduction, transfer, publication or disclosure is prohibited except as specifically provided for in your License Agreement with Software AG
 *
 * $Id: ApamaTypes.h 249541 2015-03-09 11:42:24Z bsp $
 */

#ifndef _APBUILD_APAMATYPES_H__
#define _APBUILD_APAMATYPES_H__


#include <AP_Types.h>

typedef AP_int64 int64;
typedef AP_uint64 uint64;

typedef AP_int32 int32;
typedef AP_uint32 uint32;

typedef AP_int16 int16;
typedef AP_uint16 uint16;

typedef AP_int8 int8;
typedef AP_uint8 uint8;

typedef AP_float64 float64;

typedef AP_char8 char8;

typedef uintptr_t uintptr;

#ifdef _WIN32

#include <stdint.h>
#define PRIu64	"I64u"
#define PRId64	"I64d"
#define PRIx64	"I64x"
#define PRIu32	"I32u"
#define PRId32	"I32d"
#define PRIx32	"I32x"
#define PRIu16	"I16u"
#define PRId16	"I16d"
#define PRIx16	"I16x"
#endif


#endif // _APBUILD_APAMATYPES_H__
